function Shoppingcart(options){
	options.InstanceName = options.InstanceName || 'shoppingCart';
	this.type = options.type || 'snack';
	this.callback = options.callback || null;
	this.update();
	this.listener();
	
	var updateFn = plus.webview.currentWebview().id + '--' + options.InstanceName;
	var pages = localStorage[this.type + 'Page'] ? JSON.parse(localStorage[this.type + 'Page']) : [];
	pages.indexOf(updateFn) == -1 && pages.push(updateFn);
	localStorage[this.type + 'Page'] = JSON.stringify(pages);
}

Shoppingcart.prototype = {
	constructor:Shoppingcart,
	listener:function(){
		var _this = this;
		mui('body').on('tap','.shop-' + this.type,function(event){
			event.stopPropagation();
			var _id = this.dataset.gid,
				_count = _this.data[_id];
			if(event.target.classList.contains('icon-add')){
				_count ? _count++ : _count = 1;
				_this.data[_id] = _count;
			}else if(event.target.classList.contains('icon-less')){
				_count--;
				if(_count > 0){
					_this.data[_id] = _count;
				}else{
					delete _this.data[_id];
				}
			}
			_this.save(_id);
		});
	},
	save:function(id){
		localStorage[this.type + 'Cart'] = JSON.stringify(this.data);
		if(id){
			id = Array.isArray(id) ? JSON.stringify(id) : JSON.stringify([id]);
		}
		
		//关联页面同步更新
		var savePages = false,
			_pages = JSON.parse(localStorage[this.type + 'Page']);
		mui.each(_pages.concat(),function(i,n){
			var arr = n.split('--');
			if(plus.webview.getWebviewById(arr[0])){
				plus.webview.getWebviewById(arr[0]).evalJS(arr[1] + '.update(' + id + ')');
			}else{
				_pages.splice(_pages.indexOf(n),1);
				savePages = true;
			}
		});
		//删除已关闭的页面
		if(savePages) localStorage[this.type + 'Page'] = JSON.stringify(_pages);
	},
	update:function(id){
		this.data = localStorage[this.type + 'Cart'] ? JSON.parse(localStorage[this.type + 'Cart']) : {};
		var sum = 0;
		mui.each(this.data,function(i,n){sum += n});
		if(document.querySelector('.shoppingcart-sum')) document.querySelector('.shoppingcart-sum').innerText = sum;
		
		if(id){
			for(var i in id){
				var _id = id[i];
				if(document.querySelector('.shop-select[data-gid="' + _id + '"]')){
					var count = this.data[_id],
						el = document.querySelector('.shop-select[data-gid="' + _id + '"]');
					if(count){
						el.classList.remove('empty');
						el.querySelector('font').innerText = count;
					}else{
						el.classList.add('empty');
						el.querySelector('font').innerText = 0;
					}
				}
				typeof this.callback === "function" && this.callback(this.type,_id,count);
			}
		}
	}
}