/*项目独立全局js*/
mui.ready(function() {
	//加载svg图标字体文件
	loadJs('http://at.alicdn.com/t/font_592527_35h9stw3bcr9hpvi.js');
	//openwindow打开窗口
	mui('body').on('tap', '[data-openwindow]', function() {
		if(!this.hasAttribute('data-openwindow-disabled')){
			openWindow(JSON.parse(this.getAttribute('data-openwindow')));
		}
	});
});

mui.plusReady(function() {
	//拨打电话
	mui('body').on('tap','[data-paas-dial]',function(){
		var telNumber = this.getAttribute('data-paas-dial') || this.textContent;
		mui.confirm('拨打电话：' + telNumber,'',['取消','拨打'], function(e){
			e.index && plus.device.dial(telNumber, true);
		});
	});
});
//动态加载js
function loadJs(src){
	var scriptObj = document.createElement("script");
	scriptObj.src = src;
	scriptObj.type = "text/javascript";
	document.head.appendChild(scriptObj);
}
//打开新页面
function openWindow(customize){
	if(!customize.hasOwnProperty('url')){
		throw new Error('openWindow()：参数必须是json类型并带有url属性');
	}
	var _option = {
		show:{
			duration: mui.os.ios ? 200 : 300,
		},
		waiting:{
			autoShow:false
		}
	};
	//判断是否使用原生导航栏
	if(customize.styles && customize.styles.titleNView){
		_option.styles = {
			titleNView: { //详情页原生导航配置
				backgroundColor: '#fff', //导航栏背景色
				autoBackButton: true, //自动绘制返回箭头
				//titleText: '', //导航栏标题
				//type: 'transparent', //透明渐变样式
			}
		};
	}else{
		_option.styles = {
			statusbar:{background:'#fff'}
		};
	}
	_option = mui.extend(true,_option,customize);
	//如果同名id已存在则关闭前一个页面
	if(plus.webview.getWebviewById(_option.id)){
		plus.webview.close(_option.id,'none');
		mui.later(function(){mui.openWindow(_option)},0);
	}else{
		mui.openWindow(_option);
	}
	//去除焦点
	mui('input,textarea').each(function() {
		this.blur();
	});
}

//加载轮播图
function loadSlider(args){
	var _option = mui.extend({
		imgArr:[],
		container:'.img-slider',
		verticalCenter:false,
		interval:3000
	},args);
	
	var slider = document.querySelector(_option.container);
	var len = _option.imgArr.length;
	if(len == 0){
		slider.style.display = 'none';
	}else if(len == 1){
		slider.innerHTML = '<div class="mui-slider-group"><div class="mui-slider-item"><div>' + _option.imgArr[0] + '</div></div></div>';
	}else{
		slider.innerHTML = '<div class="mui-slider-group mui-slider-loop"></div><div class="mui-slider-indicator"></div>';
		var itemHtml = '<div class="mui-slider-item mui-slider-item-duplicate"><div>' + _option.imgArr[len - 1].replace(/data-preview-native-src/,'data-nopreview') + '</div></div>';
		var indicatorHtml = '<div class="mui-indicator mui-active"></div>' + '<div class="mui-indicator"></div>'.repeat(len-1);
		mui.each(_option.imgArr,function(i,n){
			itemHtml += '<div class="mui-slider-item"><div>' + _option.imgArr[i] + '</div></div>';
		});
		itemHtml += '<div class="mui-slider-item mui-slider-item-duplicate"><div>' + _option.imgArr[0].replace(/data-preview-native-src/,'data-nopreview') + '</div></div>';
		slider.querySelector('.mui-slider-group').innerHTML = itemHtml;
		slider.querySelector('.mui-slider-indicator').innerHTML = indicatorHtml;
		
		mui(_option.container).slider({interval: _option.interval});
	}
	
	//图片垂直居中
	if(_option.verticalCenter){
		slider.classList.add('vertical-center');
		mui(_option.container + ' .mui-slider-item img').each(function(){
			this.onload = function(){
				var divheight = slider.offsetWidth;
				var imgheight = this.offsetHeight;
				if(imgheight < divheight && imgheight != 0){
					this.style.marginTop = (divheight - imgheight)/2 + 'px';
				}
			};
		});
	}
}
//原生图片预览
function previewImageNative(){
	// 监听图片的点击
	mui('body').on('tap', 'img[data-preview-native-src]', function() {
		var _src = this.getAttribute('data-preview-native-src') || this.src;
		var _srcList = [];
		//判断是否有分组
		if(this.getAttribute('data-preview-native-group')){
			var _selector = 'img[data-preview-native-src][data-preview-native-group="' + this.getAttribute('data-preview-native-group') + '"]';
		}else{
			var _selector = 'img[data-preview-native-src]:not([data-preview-native-group])';
		}
		//获取当前组的图片列表
		mui(_selector).each(function(){
			_srcList.push(this.getAttribute('data-preview-native-src') || this.src);
		});
		//原生控件预览图片
		plus.nativeUI.previewImage(_srcList, {
		    current: _srcList.indexOf(_src),
		    indicator:_srcList.length > 1 ? 'default' : 'none'
	   });
	});
}
//ajax请求封装
function ajax(param) {
	param = mui.extend({
		path:'',
		data:{},
		successFn:new Function(),
		errorFn:function(text,type,err){
			plus.nativeUI.closeWaiting();
			console.log('请求路径：'+_url+'   错误参数：'+JSON.stringify(param.data)+'  错误信息：'+text.responseText);
			try{
				if(JSON.parse(text.responseText).Code == '-2'){
					if(JSON.parse(text.responseText).Msg != "no privilege on 'SystemUser.read'"){
						mui.alert(JSON.parse(text.responseText).Msg);
					}
					//mui.alert(JSON.parse(text.responseText).Msg);
				}else if (type === "timeout") {
					mui.toast("网络连接超时，请重新进入");
				}else if(type === "abort") {
				}else{
					mui.toast("网络连接不可用，请调整重试");
				}
			}catch(e){
				mui.alert("服务器响应失败!");
			}
		},
		showWaiting:true,
		closeWaiting:true
	},param);
	
	param.showWaiting && plus.nativeUI.showWaiting();
	var _url = 'http://14.18.71.28:83/' + param.path;
	localStorage.basicRequestData && mui.extend(param.data,JSON.parse(localStorage.basicRequestData));
	mui.ajax(_url, {
		data: param.data,
		dataType: 'json',
		type: 'post',
		timeout: 20000,
		success: function(e) {
			if(param.path.toLowerCase().indexOf("api/entity") == 0){
				if(e.ErrorCode == '0'){
					param.closeWaiting && plus.nativeUI.closeWaiting();
					typeof param.successFn === "function" && param.successFn(e.Items);
				}else if(e.ErrorCode == '-100'){
					plus.nativeUI.closeWaiting();
					if(!localStorage.showConfirm){
						localStorage.showConfirm = true;
						mui.confirm(e.ErrorMsg,'',['重新登录'],logout);
					}
				} else {
					console.log('请求路径：'+_url+'   错误参数：'+JSON.stringify(param.data));
					plus.nativeUI.closeWaiting();
					mui.alert(e.ErrorMsg);
				}
			}else{
				if(e.Code == '200'){
					param.closeWaiting && plus.nativeUI.closeWaiting();
					typeof param.successFn === "function" && param.successFn(e.Data);
				}else if(e.Code == '-100'){
					plus.nativeUI.closeWaiting();
					if(!localStorage.showConfirm){
						localStorage.showConfirm = true;
						mui.confirm(e.Msg,'',['重新登录'],logout);
					}
				} else {
					console.log('请求路径：'+_url+'   错误参数：'+JSON.stringify(param.data));
					plus.nativeUI.closeWaiting();
					mui.alert(e.Msg);
				}
			}
		},
		error: param.errorFn
	});
}
//游客调用的接口
function ajaxVisitor(param) {
	param = mui.extend({
		path:'',
		data:[],
		successFn:new Function(),
		errorFn:function(text,type,err){
			plus.nativeUI.closeWaiting();
			console.log('请求路径：'+param.path+'  错误信息：'+text.responseText+'   错误类型：'+type);
			try{
				if(JSON.parse(text.responseText).Code == '-2'){
					mui.alert(JSON.parse(text.responseText).Msg);				
				}else if (type === "timeout") {
					mui.toast("网络连接超时，请重新进入");
				}else if(type === "abort") {
				}else{
					mui.toast("网络连接不可用，请调整重试");
				}
			}catch(e){
				mui.alert("服务器响应失败!");
			}
		},
		showWaiting:true,
		closeWaiting:true
	},param);
	
	var _data = param.data.length ? "'" + param.data.join("','") + "'" : '';
	param.showWaiting && plus.nativeUI.showWaiting();
	mui.ajax('http://14.18.71.28:82/WebService/BaseInfo.asmx/WebExecProcedure', {
		data: {procedureName:param.path,parameter:_data},
		dataType: 'jsonp',
		type: 'post',
		timeout: 20000,
		success: function(e) {
			param.closeWaiting && plus.nativeUI.closeWaiting();
			typeof param.successFn === "function" && param.successFn(eval(eval(e)));
		},
		error: param.errorFn
	});
}
//封装获取验证码
function getcode(obj,phone, callback) {
	if(obj.innerText === "获取验证码") {
		plus.nativeUI.showWaiting();
		mui.ajax('http://14.18.71.28:82/WebService/BaseInfo.asmx/ShortMessageApi', {
			data: {tel:phone},
			dataType: 'json',
			type: 'post',
			timeout: 20000,
			success: function(e) {
				plus.nativeUI.closeWaiting();
				if(e.msg == 'ok'){
					mui.toast("验证码已发送到您手机");
					obj.value = e.code;
					var dtime = 60;
					var counttime = setInterval(function() {
						dtime--;
						obj.setAttribute('disabled', 'disabled');
						obj.innerText = dtime + "s 后重发";
						if(dtime <= 0) {
							clearInterval(counttime);
							obj.removeAttribute('disabled');
							obj.innerText = "获取验证码";
						}
					}, 1000);
					typeof callback === "function" && callback(e.code);
				}else{
					mui.toast("发送失败，请重试");
				}
			},
			error: function(e) {
				plus.nativeUI.closeWaiting();
				mui.toast("发送失败，请重试");
			}
		});
	}
}
//退出登录
function logout(){
	localStorage.clear();
	openWindow({
		url:'_www/pages/account/login.html',
		id:'login',
		styles:{titleNView:{titleText:"登录",autoBackButton:false}}
	});
}
//切换菜单项
function switchMenu(wrapper,item,callback){
	mui(wrapper + ' ' + item).each(function(i,n){
		this.dataset.index = i;
	});
	mui(wrapper).on('tap',item + ':not(.mui-active)', function() {
		document.querySelector(wrapper + ' .mui-active') && document.querySelector(wrapper + ' .mui-active').classList.remove('mui-active');
		this.classList.add('mui-active');
		typeof callback === "function" && callback.call(this,Number(this.dataset.index));
	});
}
//时间字符串处理
function timeStr(str){
	return str.split('.')[0].replace(/T|Z/g,' ');
}
//对Date的扩展，将 Date 转化为指定格式的String
Date.prototype.format = function (fmt) {
    var o = {
        "M+": this.getMonth() + 1, //月份
        "d+": this.getDate(), //日
        "h+": this.getHours(), //小时
        "m+": this.getMinutes(), //分
        "s+": this.getSeconds(), //秒
        "q+": Math.floor((this.getMonth() + 3) / 3), //季度
        "S": this.getMilliseconds(), //毫秒
        "w": '日一二三四五六'[this.getDay()] //毫秒
    };
    if (/(y+)/.test(fmt)) fmt = fmt.replace(RegExp.$1, (this.getFullYear() + "").substr(4 - RegExp.$1.length));
    for (var k in o)
        if (new RegExp("(" + k + ")").test(fmt)) fmt = fmt.replace(RegExp.$1, (RegExp.$1.length == 1) ? (o[k]) : (("00" + o[k]).substr(("" + o[k]).length)));
    return fmt;
}
//监测更新
function checkUpdate(){
	//先获取本地版本号
	plus.runtime.getProperty(plus.runtime.appid,function(inf){
		var currentVersionStr = inf.version;
		var currentVersion = currentVersionStr.split('.');
		var curVerNumber = currentVersion.join('');
		//先判断整包下载，再判断资源升级
		var query = {QueryId:'db9eb583-c755-4000-a1ec-08d9998150f2',Page: 1,PageSize: 1,Filter:{FilterOperator:0,Conditions:[
			{attributename:'appversiontype',operator:0,values:[0]}
		]}};
		ajax({
			path:'api/entity/queryview',
			data:{query:JSON.stringify(query)},
			showWaiting:false,
			closeWaiting:false,
			successFn:function(e){				
				var apkVersion = e.length ? e[0].name.split('.') : [1,0,0];
				var apkVerNumber = apkVersion.join('');
				if(curVerNumber.length > apkVerNumber.length) apkVerNumber += '0'.repeat(curVerNumber.length - apkVerNumber.length);
				if(currentVersion[0] == apkVersion[0] && currentVersion[1] == apkVersion[1]){
					query.Filter.Conditions[0].values = [1];
					ajax({
						path:'api/entity/queryview',
						data:{query:JSON.stringify(query)},
						showWaiting:false,
						closeWaiting:false,
						successFn:function(datas){
							if(datas.length){
								var newVersion = datas[0].name.split('.');
								if(currentVersion[0] == newVersion[0] && currentVersion[1] == newVersion[1] && currentVersion[2] < newVersion[2]){
									downWgt(datas[0].appversionurl);
								}
							}
						}
					});
				}else if(e.length && parseInt(curVerNumber) < parseInt(apkVerNumber)){
					data = e[0];
					mui.alert(data.appdesc, '新版本更新', '立即更新', function(e) {
						if(mui.os.android){
							downWgt(data.appversionurl);
						}else{
							plus.runtime.openURL("https://itunes.apple.com/cn/app/%E5%90%83%E5%A5%BD%E7%82%B9app/id1214835688?mt=8")
						}
					})
				}
			}
		});
    });
   
    //下载在线升级包wgt文件
	function downWgt(wgtUrl){
	    plus.nativeUI.showWaiting("下载更新文件...");//不要提示下载
	    plus.downloader.createDownload( wgtUrl, {filename:"_doc/update/"}, function(d,status){	    	
	        if ( status == 200 ) {
	            //安装wgt包
	            plus.nativeUI.showWaiting("安装更新文件...");
			    plus.runtime.install(d.filename,{},function(){
			        plus.nativeUI.closeWaiting();
			        plus.nativeUI.alert("应用资源更新完成！",function(){
				        plus.runtime.restart();
			        });
			    },function(e){
			        plus.nativeUI.closeWaiting();
			        plus.nativeUI.alert("安装更新文件失败");
			    });
	        } else {
	        	plus.nativeUI.closeWaiting();
	            plus.nativeUI.alert("下载更新文件失败！");
	        }
	    }).start();
	}
}


//抛出错误
function assert(condition,message){
	//使用三元运算符会报错
	if(!condition) throw new Error(message);
}











//覆写兼容性不高的es6语法
String.prototype.repeat = String.prototype.repeat || function(count) {
    'use strict';
    if (this == null) {
      throw new TypeError('can\'t convert ' + this + ' to object');
    }
    var str = '' + this;
    count = +count;
    if (count != count) {
      count = 0;
    }
    if (count < 0) {
      throw new RangeError('repeat count must be non-negative');
    }
    if (count == Infinity) {
      throw new RangeError('repeat count must be less than infinity');
    }
    count = Math.floor(count);
    if (str.length == 0 || count == 0) {
      return '';
    }
    // Ensuring count is a 31-bit integer allows us to heavily optimize the
    // main part. But anyway, most current (August 2014) browsers can't handle
    // strings 1 << 28 chars or longer, so:
    if (str.length * count >= 1 << 28) {
      throw new RangeError('repeat count must not overflow maximum string size');
    }
    var rpt = '';
    for (;;) {
      if ((count & 1) == 1) {
        rpt += str;
      }
      count >>>= 1;
      if (count == 0) {
        break;
      }
      str += str;
    }
    // Could we try:
    // return Array(count + 1).join(this);
    return rpt;
}

String.prototype.includes = String.prototype.includes || function(search, start) {
    'use strict';
    if (typeof start !== 'number') {
      start = 0;
    }
    
    if (start + search.length > this.length) {
      return false;
    } else {
      return this.indexOf(search, start) !== -1;
    }
}

String.prototype.startsWith = String.prototype.startsWith || function(searchString, position){
    return this.substr(position || 0, searchString.length) === searchString;
}

String.prototype.endsWith = String.prototype.endsWith || function(searchStr, Position) {
    // This works much better than >= because
    // it compensates for NaN:
    if (!(Position < this.length))
        Position = this.length;
    else
        Position |= 0; // round position
    return this.substr(Position - searchStr.length,searchStr.length) === searchStr;
};

if (typeof Object.assign != 'function') {
  Object.assign = function(target, varArgs) { // .length of function is 2
    'use strict';
    if (target == null) { // TypeError if undefined or null
      throw new TypeError('Cannot convert undefined or null to object');
    }

    var to = Object(target);

    for (var index = 1; index < arguments.length; index++) {
      var nextSource = arguments[index];

      if (nextSource != null) { // Skip over if undefined or null
        for (var nextKey in nextSource) {
          // Avoid bugs when hasOwnProperty is shadowed
          if (Object.prototype.hasOwnProperty.call(nextSource, nextKey)) {
            to[nextKey] = nextSource[nextKey];
          }
        }
      }
    }
    return to;
  };
}

if (!Object.keys) {
  Object.keys = (function () {
    var hasOwnProperty = Object.prototype.hasOwnProperty,
        hasDontEnumBug = !({toString: null}).propertyIsEnumerable('toString'),
        dontEnums = [
          'toString',
          'toLocaleString',
          'valueOf',
          'hasOwnProperty',
          'isPrototypeOf',
          'propertyIsEnumerable',
          'constructor'
        ],
        dontEnumsLength = dontEnums.length;

    return function (obj) {
      if (typeof obj !== 'object' && typeof obj !== 'function' || obj === null) throw new TypeError('Object.keys called on non-object');

      var result = [];

      for (var prop in obj) {
        if (hasOwnProperty.call(obj, prop)) result.push(prop);
      }

      if (hasDontEnumBug) {
        for (var i=0; i < dontEnumsLength; i++) {
          if (hasOwnProperty.call(obj, dontEnums[i])) result.push(dontEnums[i]);
        }
      }
      return result;
    }
  })()
};